// *** affectation.c //

// Module d'affectation

#include <stdlib.h>
#include <stdio.h>

#include "constante.h"
#include "structure.h"
#include "affectat.h"
#include "critere.h"
#include "maint.h"

// prototypes des fonctions du module
int possible_alloc(ptorder, int, int);
int maintenance();
void allocation(ptorder, int, int);
void list_maint(int, int);
void buy_opti(int);
void substitution(int);

// Acces variables globales
extern int nb_ressources;

extern int Ressources[MAX_RES][12];
extern ptorder List_order[MAX_RES];
extern ptaffect List_affect[MAX_RES*MAX_VEH];
extern ptrent List_rent[MAX_RES];
extern ptcellu List_sub[MAX_RES];
extern ptint_maint List_int_maint[MAX_RES*MAX_VEH];
extern int Veh_Sup[MAX_RES];
extern int Aff[MAX_VEH][MAX_ORDER_VEH];

void affectation(int cplex)
{
int r, v, i, j, index, OK;

int ordre[MAX_RES];

ptorder po;
ptaffect pa;
ptrent pr;
ptint_maint pi;

// --- pour toutes les ressources

// En deux phases ...

// Allocation des vehicules possedes

// Classement des ressources
// Ordre decroissant des prix de location
for (i=1; i<=nb_ressources; i++)
	ordre[i] = i;
	
for (i=1; i<=nb_ressources; i++)
	for (j=1; j<=nb_ressources-i; j++)
		if((Ressources[ordre[j]][6]) < (Ressources[ordre[j+1]][6]))
			{
			r = ordre[j];
			ordre[j] = ordre[j+1];
			ordre[j+1] = r;
			}

// Pour toutes les ressources prise dans cet ordre
// -----------------------------------------------
for (i = 1; i<=nb_ressources; i++)
	{
	r = ordre[i];
	
	// Recherche d'une affectation optimale (CPLEX)
	// --------------------------------------------
	if (cplex ==1)
		aff_opti(r, Ressources[r][2]);
	
	// Pour tous les vehicules possedes (prendre dans l'ordre du plus charge??)
	// --------------------------------
	// Essai d'affecter les orders donnes par l'affectation optimale
	// -------------------------------------------------------------

	for (v = 1; v <= Ressources[r][2] ; v++)
		{
		po = List_order[r];
		index = 1;
		while ( po != NULL)
			{
			if ( (Aff[v][index] == 1) && (po->alloc < po->rq) )	// Recherche affectation
				{
				if (possible_alloc(po,r,v)==1)
					{
					if (maintenance(0)==1)
						allocation(po,r,v);
					else
						list_maint(r,v);
					}
				}
			index ++;
			po = po->next;
			}
		}
	
	
	// Pour tous les vehicules possedes
	// --------------------------------
	// Essai d'affecter les orders non encore affectes
	// -----------------------------------------------
	for (v = 1; v <= Ressources[r][2] ; v++)
		{
		po = List_order[r];
		while ( po != NULL)
			{
			// Recherche Affectation
			if ( (po->alloc) < (po->rq) )	
				{
				if (possible_alloc(po,r,v)==1)
					{
					if (maintenance(0)==1)
						allocation(po,r,v);
					else
						list_maint(r,v);
					}
				}
			po = po->next;
			}
		}
	}
	
	
// *** Deuxieme phase (Si achat)
// *** -------------------------

			
printf("\n Deuxieme phase \n ");

	
// Classement des ressources
// Ordre decroissant des prix location
/*for (i=1; i<=nb_ressources; i++)
	ordre[i] = i;
	
for (i=1; i<=nb_ressources; i++)
	for (j=1; j<=nb_ressources-i; j++)
		if((Ressources[ordre[j]][6]) < (Ressources[ordre[j+1]][6]))
			{
			r = ordre[j];
			ordre[j] = ordre[j+1];
			ordre[j+1] = r;
			}*/
			
			
// Allocation des vehicules pouvant etre achetes
// ---------------------------------------------
for (i = 1; i<=nb_ressources; i++)
	{
  	r = ordre[i];
  	if (Ressources[r][12] > 0)
		{
	
	// Recherche d'une affectation optimale (CPLEX)
	// --------------------------------------------
	po = List_order[r];
	OK = 0;
	while (po != NULL)
		{
		if (po->rq > po->alloc)
			OK = 1;
		po = po->next;	
		}
	if ( (OK == 1) && (cplex ==1))
		aff_opti(r, Ressources[r][12]);
	
	// Pour tous les vehicules pouvant etre achete
	// -------------------------------------------
	// Essai d'affecter les orders donnes par l'affectation optimale
	// -------------------------------------------------------------
	for (v = Ressources[r][2] + 1; v <= Ressources[r][2] + Ressources[r][12] ; v++)
		{

		po = List_order[r];
		index = 1;
		while ( po != NULL)
			{
			if ( (Aff[v-Ressources[r][2]][index] == 1) && (po->alloc < po->rq) )	// Recherche affectation
				{
				if (possible_alloc(po,r,v)==1)
					{
					if (maintenance(0)==1)
						allocation(po,r,v);
					else
						list_maint(r,v);
					}
				}
			index ++;
			po = po->next;
			}
		}
		
	
	
	// Pour tous les vehicules pouvant etre achete
	// -------------------------------------------
	// Essai d'affecter les orders non encore affectes
	// -----------------------------------------------	
	for (v = Ressources[r][2] + 1; v <= Ressources[r][2] + Ressources[r][12] ; v++)
		{
		po = List_order[r];
		while ( po != NULL)
			{
			if ( (po->alloc) < (po->rq) )	// Recherche affectation
				{
				if (possible_alloc(po,r,v)==1)
					{
					if (maintenance(0)==1)
						allocation(po,r,v);
					else
						list_maint(r,v);
					}
				}
			po = po->next;
			}
		  }
		}
	}
	
// Troisieme phase : Locations et optimisation
// -------------------------------------------
// Location des ordres qui restent 
for (i = 1; i<=nb_ressources; i++)
	{
	r = ordre[i];
	po = List_order[r];
	while ( po != NULL)
		{
		if ( (po->alloc) < (po->rq) )
			rent_car(po, po->rq - po->alloc);
		po = po->next;
		}	
	if (Ressources[r][12]>0)
		buy_opti(r);	
	}	
	
	
// Recherche des substitutions eventuelles
// ---------------------------------------
// Prendre les ressources dans l'ordre decroissant du prix de location
// -------------------------------------------------------------------
for (i=1; i<=nb_ressources; i++)
	ordre[i] = i;
	
for (i=1; i<=nb_ressources; i++)
	for (j=1; j<=nb_ressources-i; j++)
		if((Ressources[ordre[j]][6]) < (Ressources[ordre[j+1]][6]))
			{
			r = ordre[j];
			ordre[j] = ordre[j+1];
			ordre[j+1] = r;
			}
	
//for (i=1; i<=nb_ressources; i++)
//	printf(" %i ", ordre[i]);	
	
for (i=1; i<=nb_ressources; i++)
	{
	r = ordre[i];
	substitution(r);	
	}

r = maintenance(1);

}

// --- Procedure de verification d'allocation
// --- ======================================
int possible_alloc(ptorder ord, int type, int veh)
{
int OK, cumul, sft, eft, insert;
ptaffect pra, interm, na, pna;
ptint_maint pi, pni, ni;

OK = 1;

if (List_affect[(type-1) * MAX_VEH + veh] != NULL)
	{
	// Verification de non chevauchement
	pra = List_affect[(type-1) * MAX_VEH + veh];
	while  (pra != NULL)  
	  {
	  if   ( (pra->st <= ord->st ) && (pra->et > ord->st ) ) 
	  		OK = 0;
	  else if		
		    ( (pra->st <= ord->et ) && (pra->et > ord->et ) ) 
		    OK = 0;
	  else if
		    ( (pra->st >= ord->st ) && (pra->et <= ord->et) ) 
		  	OK = 0;
	  pra = pra->next;
	  }
	  
	 if (OK == 1)
	 	{
	 	// Calcul des intervalles de maintenance
	 	
	 	// Eliminer ancienne liste de maintenance
	 	if (List_int_maint[(type-1) * MAX_VEH + veh] != NULL)
	 		{
	 		pi = List_int_maint[(type-1) * MAX_VEH + veh];
	 		while (pi != NULL)
				{
				pni = pi->next;
				free(pi);
				pi = pni;
				}
			 List_int_maint[(type-1) * MAX_VEH + veh] = NULL;
	 		}
	 			 		
	 	// Copie de la liste des affectations dans interm
	 	// (en inserant le nouvel order)
	 	
	 	pra = List_affect[(type-1) * MAX_VEH + veh];
	 	interm = NULL;
	 	insert = 0;
	 	
	 	while  (pra != NULL)  
	  		{
	  		na = (ptaffect) malloc (sizeof(taffect));
	  		na->next = NULL;
	  		
	  		if ( (ord->st < pra->st) && (insert == 0) )
	  			{
				na->order = ord;
				na->st = ord->st;
				na->et = ord->et;
				
				insert = 1;
				}
			else	
	  			{
				na->order = pra->order;
				na->st = pra->st;
				na->et = pra->et;
		
				pra = pra-> next;
				}

	  		if (interm == NULL)
	  			{
	  			interm = na;
	  			pna = interm;
	  			}
	  		else	
	  			{
	  			pna->next = na;
	  			pna = na;
	  			}
	  			
	  		}
	  		
	  		if (insert == 0)
	  			{
	  			na = (ptaffect) malloc (sizeof(taffect));
	  			na->order = ord;
				na->st = ord->st;
				na->et = ord->et;
	  			na->next = NULL;
	  			
	  			insert = 1;
	  			
	  			pna->next = na;
	  			}
	  		
	  		// Parcours de la liste et determination des maintenances
	  		pna = interm;
	  		cumul = 0;
	  		sft = 0;
	  		eft = 0;
	  		while ( (pna->next) != NULL)
	  		  {
	  		  cumul = cumul + pna->et - pna->st;
	  		  sft = pna->et;
	  		  eft = (pna->next)->st;
	 	
	 		  if (cumul + (pna->next)->et - (pna->next)->st > Ressources[type][3])
	 			{
	 			
	 			// Lancer une maintenance
	 			cumul = 0;
	 			ni = (ptint_maint) malloc (sizeof(tint_maint));
	 			ni->rtype_id = type;
	 			ni->item_id = veh;
	 			ni->st = sft;
	 			ni->et = eft;
	 			ni->next = NULL;
	 			if (List_int_maint[(type-1) * MAX_VEH + veh] == NULL)
	 				List_int_maint[(type-1) * MAX_VEH + veh] = ni;
	 			else
	 				{
	 				pi = List_int_maint[(type-1) * MAX_VEH + veh];
	 				while (pi != NULL)
	 					{
	 					pni = pi;
	 					pi = pi->next;
	 					}
	 				pni->next = ni;	
	 				} 				
	 				
	 			}	
	 		  pna = pna->next;
	 		  }
	 		  
	 		 // Eliminer liste interm
	 		
	 		if (interm != NULL)
	 			{
	 			pra = interm;
	 			while (pra != NULL)
					{
					pna = pra->next;
					free(pra);
					pra = pna;
					}
			 	interm = NULL;
	 			} 
	 		
	 	} 
	}
	
return(OK);
}



// --- Procedure de recalcul de la liste des maintenances
// --- ==================================================
void list_maint(int type, int veh)
{
int  cumul, sft, eft, insert;
ptaffect pra, interm, na, pna;
ptint_maint pi, pni, ni;


if (List_affect[(type-1) * MAX_VEH + veh] != NULL)
	{

	// Calcul des intervalles de maintenance
	 	
	 // Eliminer ancienne liste de maintenance
	 // printf("\n Eliminer ancienne liste veh %i\n", veh);
	 if (List_int_maint[(type-1) * MAX_VEH + veh] != NULL)
	 	{
	 	pi = List_int_maint[(type-1) * MAX_VEH + veh];
	 	while (pi != NULL)
			{
			pni = pi->next;
			free(pi);
			pi = pni;
			}
			List_int_maint[(type-1) * MAX_VEH + veh] = NULL;
	 	}
	 		
	  		
	  // Parcours de la liste et determination des maintenances
	  pna = List_affect[(type-1) * MAX_VEH + veh];
	  cumul = 0;
	  sft = 0;
	  eft = 0;
	  while ( (pna->next) != NULL)
	  	{
	  	cumul = cumul + pna->et - pna->st;
	  	sft = pna->et;
	  	eft = (pna->next)->st;
	 	
	 	if (cumul + (pna->next)->et - (pna->next)->st > Ressources[type][3])
	 		{
	 		
	 		// Lancer une maintenance
	 		cumul = 0;
	 		ni = (ptint_maint) malloc (sizeof(tint_maint));
	 		ni->rtype_id = type;
	 		ni->item_id = veh;
	 		ni->st = sft;
	 		ni->et = eft;
	 		ni->next = NULL;
	 		if (List_int_maint[(type-1) * MAX_VEH + veh] == NULL)
	 				List_int_maint[(type-1) * MAX_VEH + veh] = ni;	// Premier
	 		else
	 			{
	 			pi = List_int_maint[(type-1) * MAX_VEH + veh];
	 			while (pi != NULL)
	 				{
	 				pni = pi;
	 				pi = pi->next;
	 				}
	 			pni->next = ni;	
	 			} 				
	 				
	 		}	
	 		pna = pna->next;
	 	}		
	  
	}
	
}




// --- Procedure d'allocation
// --- ======================
void allocation(ptorder pto, int type, int veh)
{

ptaffect pa, pra, na;

na = (ptaffect) malloc (sizeof(taffect));
na->order = pto;
na->st = pto->st;
na->et = pto->et;
na->next = NULL;


if (List_affect[(type-1) * MAX_VEH + veh] == NULL)	// Premiere affectation
	List_affect[(type-1) * MAX_VEH + veh] = na;
else
	{
	pa = List_affect[(type-1) * MAX_VEH + veh];
	if (pa->st > pto->st)	// Ajout tete
		{
		List_affect[(type-1) * MAX_VEH + veh] = na;
		na->next = pa;
		}
	else
		{
		while  ( (pa->next != NULL) && (pa->st < pto->st) )
			{
			pra = pa;
			pa = pa->next;
			} 
		if (pa->st > pto->st)	// ajout central
			{
			pra->next = na;
			na->next = pa;
			}
		else	// Ajout en fin
			pa->next = na;
		}
	}
	
pto->alloc ++;

}


// Procedure de location
// ---------------------
void rent_car(ptorder ord, int number)
{
ptrent pr, prr, nr;

nr = (ptrent) malloc (sizeof(trent));
nr->order = ord;
nr->rtype_id = ord->rtype_id;
nr->order_id = ord->order_id;
nr->st = ord->st;
nr->et = ord->et;
nr->r_number = number;
nr->next = NULL;

ord->alloc = ord->alloc + number;

if (List_rent[ord->rtype_id] == NULL)
	List_rent[ord->rtype_id] = nr;	// premier
else
	{
	pr = List_rent[ord->rtype_id];
	if (ord->order_id <= pr->order_id)	// Ajout tete
		{
		List_rent[ord->rtype_id] = nr;
		nr->next = pr;
		}
	else
		{
		while ( (pr->next != NULL) && (ord->order_id > pr->order_id) )
			{
			prr = pr;
			pr = pr->next;
			}
		if (ord->order_id <= pr->order_id)	// Ajout central
			{
			prr->next = nr;
			nr->next = pr;
			}
		else	// Ajout en fin
			pr->next = nr;
		}
	}
}

// Procedure d'optimisation des achats
// -----------------------------------
void buy_opti(int r)
{
ptaffect pa, pna;
ptint_maint pni;
int nb_veh_used, v, i;
int nb_loc;
int loca[MAX_VEH];
int min, index;

nb_veh_used = 0;
nb_loc = 0;
//fprintf(pt_fichier," \n Optimisation Achat ress %i",r);

// Decompte du nombre de vehicules utilises
for (v = 1; v <= Ressources[r][2] + Ressources[r][12]; v++)
	if (List_affect[(r-1)*MAX_VEH + v] != NULL)
		nb_veh_used ++;

// Decompte du nombre de voitures qu'il serait preferable de louer	
// ie celles dont le cout d'achat est > cout de location
if (nb_veh_used > Ressources[r][2])
	{
	 for (v = 1; v <= nb_veh_used; v++)
	 	{
	 	if (cout_achat(r,v) > cout_location(r,v))
	 		{
	 		nb_loc++;
	 		loca[v] = cout_achat(r,v) - cout_location(r,v);
	 		}
	 	else
	 		loca[v] = MAX;
	 	}
	}
	
// Choix des locations eventuelles	

// Cas ou l'on devra acheter des voitures	
while ( (nb_veh_used > Ressources[r][2])	
		&& (nb_loc > 0)
		&& (nb_loc < Ressources[r][12]) )
		{
		// recherche de la voiture a louer
		min = MAX;
		for (v = 1; v <= nb_veh_used; v++)
	 		{
	 		if ((loca[v] < min) && (List_affect[(r-1)*MAX_VEH + v] != NULL) )
	 			{
	 			index = v;
	 			min = loca[v];
	 			}
	 		}
	 		
	 	// Cas ou l'on loue la derniere voiture
			if (index == nb_veh_used)
				Ressources[r][12]--;
			
	 		
	 	// Louer la voiture index
	 	if (List_affect[(r-1)*MAX_VEH + index] == NULL)
	 		{
	 		printf("\n ATTENTION 1 : Location d'un vehicule non utilise ");
	 		nb_loc--;
	 		}
	 	else
			{
			pa = List_affect[(r-1)*MAX_VEH + index];
			while (pa != NULL)
				{
				pna = pa->next;
				(pa->order)->alloc--;
				rent_car(pa->order, 1);
				free(pa);
				pa = pna;
				}
				
			// Echange de places des vehicules index et nb_veh_used
			List_affect[(r-1)*MAX_VEH + index] = List_affect[(r-1)*MAX_VEH + nb_veh_used];
			List_affect[(r-1)*MAX_VEH + nb_veh_used] = NULL;
			loca[index] = MAX;
			
			List_int_maint[(r-1)*MAX_VEH + index] = List_int_maint[(r-1)*MAX_VEH + nb_veh_used];
			List_int_maint[(r-1)*MAX_VEH + nb_veh_used] = NULL;
			
			nb_loc--;
			nb_veh_used--;
			}
		}

// Cas ou l'on ne devra PAS acheter de voitures	
if (nb_loc >= Ressources[r][12])
  while ( (nb_veh_used > Ressources[r][2])	
		&& (nb_loc > 0) )
		{
		// Comparaison entre cout de location et cout d'utilisation
		for (v = 1; v <= nb_veh_used; v++)
	 		loca[v] = cout_location(r,v) - cout_utilisation(r,v);
	 			
	 	// recherche la voiture a louer
		min = MAX;
		for (v = 1; v <= nb_veh_used; v++)
	 		{
	 		if (loca[v] < min)
	 			{
	 			index = v;
	 			min = loca[v];
	 			}
	 		}
	 		
	 	// Cas ou l'on loue la derniere voiture
			if (index == nb_veh_used)
				Ressources[r][12]--;
				
	 	// Louer la voiture index
	 	if (List_affect[(r-1)*MAX_VEH + index] == NULL)
	 		{
	 		printf("\n ATTENTION 2 : Location d'un vehicule non utilise ");
	 		nb_loc--;
	 		}
	 	else
			{
			pa = List_affect[(r-1)*MAX_VEH + index];
			while (pa != NULL)
				{
				pna = pa->next;
				(pa->order)->alloc--;
				rent_car(pa->order,1);
				free(pa);
				pa = pna;
				}
			// Echange de places des vehicules index et nb_veh_used
			List_affect[(r-1)*MAX_VEH + index] = List_affect[(r-1)*MAX_VEH + nb_veh_used];
			List_affect[(r-1)*MAX_VEH + nb_veh_used] = NULL;
			loca[index] = MAX;
			
			List_int_maint[(r-1)*MAX_VEH + index] = List_int_maint[(r-1)*MAX_VEH + nb_veh_used];
			List_int_maint[(r-1)*MAX_VEH + nb_veh_used] = NULL;

		// Decompte du nombre de location restant a faire et du nombre de vehicules utilises
			nb_loc--;
			nb_veh_used--;
			}
		}
		
// Choix des achats

if (nb_veh_used > Ressources[r][2])	
	{
	// Classer les voitures par date de debut
	for (v = 1; v <= nb_veh_used; v++)
		{
		if (List_affect[(r-1)*MAX_VEH + v] == NULL)
	 		printf("\n ATTENTION : Classement d'un vehicule non utilise ");
	 	else
			{
			pa = List_affect[(r-1)*MAX_VEH + v];
			loca[v] = pa->st;
			}
		}
	}

// Recherche des voitures a acheter
while (nb_veh_used > Ressources[r][2])	
	{
	min = 0;
	for (v = 1; v <= nb_veh_used; v++)
	 	{
	 	if (loca[v] > min)
	 		{
	 		index = v;
	 		min = loca[v];
	 		}
	 	}
	 // Acheter la voiture index
	 // echange des vehicules
	pna = List_affect[(r-1)*MAX_VEH + index];
	List_affect[(r-1)*MAX_VEH + index] = List_affect[(r-1)*MAX_VEH + nb_veh_used];
	List_affect[(r-1)*MAX_VEH + nb_veh_used] = pna;
	
	pni = List_int_maint[(r-1)*MAX_VEH + index];
	List_int_maint[(r-1)*MAX_VEH + index] = List_int_maint[(r-1)*MAX_VEH + nb_veh_used];
	List_int_maint[(r-1)*MAX_VEH + nb_veh_used] = pni;
	
	nb_veh_used--;
	}	


}

// --- Recherche des substitutions
// --- ===========================

void substitution(int res)
{
int veh, ress, sub;
ptcellu ps;
ptrent pt, ptr, liste, nr, pliste, prliste;

if (List_sub[res]->next != NULL)	// Il existe substitution
	{
	if (List_rent[res] != NULL)
		{
		// Copie de la liste dans l'ordre decroissant des longueurs
		// dans liste
		liste = NULL;
		pt = List_rent[res];
		while (pt != NULL)
			{
			
			nr = (ptrent) malloc (sizeof(trent));
			nr->order = pt->order;
			nr->rtype_id = pt->rtype_id;
			nr->order_id = pt->order_id;
			nr->st = pt->st;
			nr->et = pt->et;
			nr->r_number = pt->r_number;
			nr->next = NULL;
			
			if (liste == NULL)	// Premier
				{
				liste = nr;
				pliste = liste;
				}
			else
				{
				pliste = liste;
				if  ( (pliste != NULL) 
					&& ( (nr->et - nr->st) > (pliste->et - pliste->st)) ) 
						{
						// Ajout tete
						liste = nr;
						nr->next = pliste;
						}
				else
					{
					while ( (pliste->next != NULL)
						&& ( (nr->et - nr->st) <= (pliste->et - pliste->st)) )
						{
						prliste = pliste;
	 					pliste = pliste->next;
						}
					if ( (nr->et - nr->st) > (pliste->et - pliste->st))
						{
						// Ajout central
						prliste->next = nr;
	 					nr->next = pliste;
						}
					else 	// Ajout en fin
						{
						pliste->next = nr;	
	 					}
					}		
				}
			pt = pt->next;
			}
		}
	
	// Recherche des substitutions
	
	// Parcourir la liste des ressources substituables
	ps = List_sub[res]->next;
	while (ps != NULL)
		{
		ress = ps->nb_res;
		// Parcours de la copie des rent
		if (liste != NULL)
			{
			pliste = liste;
			prliste = liste;
			while (pliste != NULL)
				{
				sub = 0;
				veh = 1;
				while ( (veh <= Ressources[ress][2] + Ressources[ress][12]) && (sub == 0) && (pliste != NULL) )
					{
					if (List_affect[(ress-1)*MAX_VEH +veh] != NULL)  // Si le vehicule est utilise
						  // Recherche allocation
						  if (possible_alloc(pliste->order,ress,veh)==1)
							{
							if (maintenance(0)==1)
								{
								(pliste->order)->alloc --;
								allocation(pliste->order,ress,veh);
								sub = 1;
								
								// Eliminer des rents
								pt = List_rent[res];
								ptr = pt;
								while  ( (pt != NULL) && (pt->order_id != pliste->order_id) )
									{
									ptr = pt;
									pt = pt->next;
									}
								if (pt->order_id != pliste->order_id)
									printf("\n ALERTE PB RENT ");
								else
									{
									pt->r_number --;
									if (pt->r_number < 0)
										printf("\n ALERTE PB RENT 2 ");
									else if (pt->r_number == 0)
										{
										// eliminer de la liste
										if (pt == List_rent[res])
											{
											List_rent[res] = pt->next;
											free(pt);
											}
										else
											{
											ptr->next = pt->next;
											free(pt);
											}	
										}
										
									}
									
								
								// Eliminer de la liste interm
								if (liste == pliste)
									{
									liste = pliste->next;
									prliste = pliste;
									pliste = pliste->next;
									free(prliste);
									prliste = pliste;
									}
								else
									{
									pliste = pliste->next;
									free(prliste->next);
									prliste->next = pliste;
									}	
								}
							else
								{
								list_maint(ress,veh);
								}
							}
						veh ++;
						}
					if ( (pliste != NULL) && (sub == 0) )
						{
						prliste = pliste;
						pliste = pliste->next;
						}
					}
				}
		ps = ps->next;
		}	
	}
}


