// --- Module maintenance

#include <stdlib.h>
#include <stdio.h>

#include "constante.h"
#include "structure.h"
#include "maint.h"

// Acces variables globales
extern int mcap;
extern int end;
extern int nb_ressources;
extern int min_mtime;
extern int nb_decal;
extern int nb_maint;

extern int Maintenance[MAX_MCAP][MAX_TEMPS][2];
extern int Ressources[MAX_RES][12];
extern int Veh_Sup[MAX_RES];
extern ptmaint List_maint[MAX_RES*MAX_VEH];
extern ptint_maint List_int_maint[MAX_RES*MAX_VEH];


// procedure de verification de la maintenance
int maintenance(int sauv)
{
int OK, OKBIS, cher_int;
int deb_maint, fin_maint;
int r, v, k, i;
int nb_vehic;
int decal;
int imp;
ptint_maint liste, pliste, prliste, pl, pi, ni;
ptmaint pm, nm;


// Initialisation du tableau des maintenances
for (r=1; r<= mcap; r++)
	for (v=1; v<= end; v++)
		for (k=0; k<2; k++)
			Maintenance[r][v][k] = 0;

OK = 1;

nb_decal = 0;
nb_maint = 0;
imp = 0;		// Indique lorsque c'est de toute facon impossible


// Ordonner les maintenances
// En fonction de la marge initiale
liste = NULL;
for (r=1; r<= nb_ressources; r++)
	{
	nb_vehic = Ressources[r][2] + Ressources[r][12];
	for (v = 1; v <= nb_vehic; v++)
		if (List_int_maint[(r-1)*MAX_VEH + v] != NULL)
		 	{
		 	pi = List_int_maint[(r-1)*MAX_VEH + v];
		 	while   (pi != NULL) 
				{
				ni = (ptint_maint) malloc (sizeof(tint_maint));
	 			ni->rtype_id = r;
	 			ni->item_id = v;
	 			ni->st = pi->st;
	 			ni->et = pi->et;
	 			ni->next = NULL;
	 			
	 			if (liste == NULL)		// Premier
	 				{
	 				liste = ni;
	 				pliste = liste;
	 				}
	 			else
	 				{
	 				pliste = liste;
	 				if ( (ni->et - ni->st - Ressources[r][4]) <
	 					   (pliste->et - pliste->st - Ressources[pliste->rtype_id][4]) )
	 					  	{
	 					  	// Ajout tete
	 					  	liste = ni;
	 					  	ni->next = pliste;
	 					  	}
	 				else
	 					{
	 					while ( (pliste->next != NULL)
	 							&& ( (ni->et - ni->st - Ressources[r][4]) >=
	 					  (pliste->et - pliste->st - Ressources[pliste->rtype_id][4]) ) )
	 					  	{
	 					  	prliste = pliste;
	 					  	pliste = pliste->next;
	 					  	}
	 					 if ( (ni->et - ni->st - Ressources[r][4]) <
	 					  (pliste->et - pliste->st - Ressources[pliste->rtype_id][4]) )
	 					  	{
	 					  	// Ajout central
	 					  	prliste->next = ni;
	 					  	ni->next = pliste;
	 					  	}
	 					  else 	// Ajout en fin
	 					  	pliste->next = ni;	
	 					}	  	
	 				}
	 				
				pi = pi->next;
				}
			} 
	}



// Parcours de la liste et determination des maintenances
// Au plus tot
if (liste != NULL)
	{
	pliste = liste;
	while (pliste != NULL)
		{
		cher_int=1;
		if ( (pliste->et - pliste->st) < Ressources[pliste->rtype_id][4])
			OK = 0;
		else	
		  for (k=1; k<=mcap; k++)
			{
			deb_maint = pliste->st;
			while ( (cher_int == 1) 
					&& (deb_maint <= pliste->et - Ressources[pliste->rtype_id][4]) 
					&& (OK == 1) )
				{
				while  ( (Maintenance[k][deb_maint][0] != 0) 
					    && (deb_maint <= pliste->et - Ressources[pliste->rtype_id][4]) )
					deb_maint ++;
					
				fin_maint = deb_maint;
				
				while  ( (Maintenance[k][fin_maint][0] == 0) 
						&& (fin_maint < pliste->et) 
						&& (cher_int == 1) )
					{
					fin_maint++;
					if (fin_maint - deb_maint >= Ressources[pliste->rtype_id][4])
						// Maintenance
						{
						cher_int = 0;
						decal = 0;
						nb_maint++;
						
						// Decalage a droite?
						while ( (Maintenance[k][fin_maint+decal][0] == 0) 
								&& ( decal < min_mtime) 
								&& ( fin_maint + decal < pliste->et) )
								decal ++;
							
						if 	(decal >= min_mtime)
							decal = 0;	
						else
							nb_decal ++;
						
						for (v=deb_maint+decal; v< deb_maint + Ressources[pliste->rtype_id][4]+decal; v++)
							{
							Maintenance[k][v][0] = pliste->rtype_id;
							Maintenance[k][v][1] = pliste->item_id;
							}
						}
					else
						{
						// c'est impossible
						imp = 1;
						}
						
					}
				deb_maint = fin_maint;
				}
			}
		if (cher_int == 1) 
			OK = 0;
		
		// liberation de la liste
		pl = pliste;
		pliste = pliste->next;
		free(pl);
		}
	liste = NULL;	
	}
	

// Sauvegarde des maintenances dans la liste
if (sauv == 1)
	{
	// Initialisation de la liste des maintenances
	for (r = 1; r <= nb_ressources; r ++)
		{
		nb_vehic = Ressources[r][2] + Ressources[r][12];
		for (v = 1; v <= nb_vehic; v++)
			List_maint[(r-1)*MAX_VEH + v] = NULL;
		}

	// Copie du tableau dans la structure
	for (k=1; k<=mcap; k++)
		{
		i = 1;
		while (i < end) 
			{
			while ( (Maintenance[k][i][0] == 0) && (i < end))
				i++;
			if (i < end)
				{	
				nm = (ptmaint) malloc (sizeof(tmaint));
				nm->t = i;
				nm->next = NULL;
				
				if (List_maint[(Maintenance[k][i][0]-1) * MAX_VEH + Maintenance[k][i][1]] == NULL)
					List_maint[(Maintenance[k][i][0]-1) * MAX_VEH + Maintenance[k][i][1]] = nm;
				else
					{
					nm ->next = List_maint[(Maintenance[k][i][0]-1) * MAX_VEH + Maintenance[k][i][1]];
					List_maint[(Maintenance[k][i][0]-1) * MAX_VEH + Maintenance[k][i][1]] = nm;
					}
					
				}
			i = i +	Ressources[Maintenance[k][i][0]][4];
			}
		
		}
	}

return(OK);
}